"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Connection_1 = require("./Connection");
var Connector = /** @class */ (function () {
    function Connector() {
    }
    Connector.create = function (configs, defaultConn) {
        var _this = this;
        if (defaultConn === void 0) { defaultConn = ""; }
        Object.keys(configs).forEach(function (key) {
            var config = configs[key];
            var connection = _this.newConnection(key, config);
            if (key === defaultConn) {
                _this.defaultConnection = connection;
            }
        });
    };
    Connector.newConnection = function (key, config) {
        var driver = config.driver;
        var connection = new Connection_1.Connection(driver, config);
        this.connections[key] = connection;
        return connection;
    };
    Connector.closeAll = function () {
        var _this = this;
        Object.keys(this.connections).forEach(function (key) {
            _this.connections[key].close();
        });
    };
    Connector.connections = {};
    return Connector;
}());
exports.Connector = Connector;
//# sourceMappingURL=Connector.js.map